if(isFile("config/server/altAlert.cs") && !$AltAlert_Loaded) {
  exec("config/server/altAlert.cs");
  $AltAlert_Loaded = true;
}

function messageAdmins(%type, %msg, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k) {
  for(%z = 0; %z < ClientGroup.getCount(); %z++) {
    %client = ClientGroup.getObject(%z);
    if(%client.isAdmin) {
      messageClient(%client, %type, %msg, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k);
    }
  }
}

function serverCmdGetIpHistory(%client, %ip) {
  %ip = strReplace(%ip, ".", "_");
  %blids = $AltAlert::IP[%ip];
  if(strlen(trim(%blids)) == 0) {
    messageClient(%client, '', "\c1No BL_ID's associated with \"\c6" @ %ip @ "\c1\"");
    return;
  }

  for(%i = 0; %i < getFieldCount(%blids); %i++) {
    %data = getField(%blids, %i);

    %loggedBlid = getWord(%data, 0);
    %loggedDate = getWord(%data, 1);
    %loggedName = $AltAlert::Username[%loggedBlid];

    messageClient(%client, '', "\c1" @ %loggedName @ " (\c6" @ %loggedBlid @ "\c1) at \c6" @ strReplace(%loggedDate, "_", " "));
  }
}

function serverCmdGetIp(%client, %a, %b, %c, %d) {
  %username = trim(%a SPC %b SPC %c SPC %d);
  %cl = findclientbyname(%username);
  if(isObject(%cl)) {
    %addr = %cl.getAddress();
    if(strpos(%addr, ":") > 0) {
      %addr = getSubStr(%addr, 0, strpos(%addr, ":"));
    }
    messageClient(%client, '', "\c1" @ %cl.netname @ "'s ip: \c6" @ %addr);
  }
}

package AltAlert {
  function GameConnection::autoAdminCheck(%client) {
    %ret = parent::autoAdminCheck(%client);

    //Log
    %blid = %client.bl_id;

    %ip = %client.getAddress();
    if(%ip $= "local")
      return;

    %ip = strReplace(getSubStr(%ip, 0, strPos(%ip, ":")), ".", "_");

    %ips = $AltAlert::BLID[%blid];

    %add = true;
    for(%i = 0; %i < getFieldCount(%ips); %i++) {
      %data = getField(%ips, %i);

      %loggedIp = getWord(%data, 0);
      %loggedDate = getWord(%data, 1);

      if(%loggedIp $= %ip) {
        %add = false;
        %newData = setWord(%data, 1, strReplace(getDateTime(), " ", "_"));
        $AltAlert::BLID[%blid] = setField(%ips, %i, %newData); //update last seen time
        break;
      }
    }

    if(%add) {
      $AltAlert::BLID[%blid] = trim($AltAlert::BLID[%blid] TAB %ip SPC strReplace(getDateTime(), " ", "_"));
      $AltAlert::IP[%ip] = trim($AltAlert::IP[%ip] TAB %blid SPC strReplace(getDateTime(), " ", "_"));

      $AltAlert::Username[%blid] = %client.netname;
    }

    if(getFieldCount($AltAlert::IP[%ip]) > 1) {
      smessageAdmins('', "\c1Multiple BL_ID's associated with \c6" @ strReplace(%ip, "_", ".") @ "\c1, " @ %client.netname @ "'s IP. Use /getIpHistory for more info");
    }
  }

  function onExit() {
    export("$AltAlert::*", "config/server/altAlert.cs");
  }
};
activatePackage(AltAlert);
